Unit aee5e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1E_p;

function aee5e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; K :Integer): Extended;

implementation

function aee5e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; K :Integer): Extended;
var
J,L,P1 :Integer;
D,E,F,G,S,T,V,X,WMIN2,HM :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{ Result -    AEE5E  FORTRANe }
WMIN2 := SYS051;
Result := A[0];
if ( N = 1 ) 
 then goto _7;
AMA1E(A,B,N,D,E,HM,P1);
G := EMax1(Abs(E),Abs(D))*WMIN2;
S := 2.0e0*WMIN2;
_1:
F := (D+E)*0.5e0;
if ( E-D <= (Abs(E)+Abs(D))*S+G ) 
 then goto _6;
L := 0;
V := A[0]-F;
if ( V < 0.0e0 ) 
 then L := 1;
for J:=2 to N do
 begin
  T := B[J-1];
  if ( V <> 0.0e0 ) 
   then goto _2;
  X := Abs(T)/WMIN2;
  goto _3;
_2:
  X := (T/V)*T;
_3:
  V := A[J-1]-F-X;
  if ( V < 0.0e0 ) 
   then L := L+1;
_4:
 end;
if ( L >= K ) 
 then goto _5;
D := F;
goto _1;
_5:
E := F;
goto _1;
_6:
Result := F;
if ( P1 = 0 ) 
 then goto _7;
Result := F/HM;
_7:
exit;
end;

end.
